/***************************************************************|
|                    MCU Configuration Words                    |
|************************ Config_Words.h ***********************|
|    Suported MCU: PIC24FJ64GB002,PIC24FJ64GA002,PIC24FJ64GB004 |
|    Types of enviroment: USB, Others                           |
|    Written by: Written by: Diallix, Diallix Software (C)      |
|    For more info visit: http:\\www.diallix.net\fuses          |
|    Last revision code: 19.01 2021                             |
|***************************************************************|
|***************************************************************/

#define PLL_96MHZ_OFF   0xFFFF
#define PLL_96MHZ_ON    0xF7FF

#if defined(__PIC24FJ64GB002__) || defined(__PIC24FJ64GA002__) || defined(__PIC24FJ64GB004__)

	#ifndef __Diall_WORDS_HEADER__
	  #define __Diall_WORDS_HEADER__
	 #else 
	  #error "The Header of Fuses has been included!"
	#endif

	PUBLIC void SetConfig(void);

	_CONFIG1(     WDTPS_PS1 
				& FWPSA_PR32 
				& WINDIS_OFF
				& FWDTEN_OFF
				& ICS_PGx2
				& GWRP_OFF
				& GCP_OFF
				& JTAGEN_OFF
			)
	_CONFIG2(	  POSCMOD_NONE
				& I2C1SEL_PRI
				& IOL1WAY_OFF
				& OSCIOFNC_ON
				& FCKSM_CSDCMD
				#if defined(__USB_CDC_DEV_D__)
					& FNOSC_FRCPLL
					& PLL96MHZ_ON
					& PLLDIV_DIV2
				#else
					& FNOSC_FRC
                	& PLL96MHZ_OFF
					& PLLDIV_NODIV
				#endif
				& IESO_OFF
			)
	_CONFIG3(     WPFP_WPFP0
				& SOSCSEL_IO
				& WUTSEL_LEG
				& WPDIS_WPDIS
				& WPCFG_WPCFGDIS 
				& WPEND_WPENDMEM
			)
	_CONFIG4(     DSWDTPS_DSWDTPS3
				& DSWDTOSC_LPRC
				& RTCOSC_SOSC
				& DSBOREN_OFF
				& DSWDTEN_OFF
			)

    #ifndef __DISABLE_PRAGMA_CONFIG__
    	#pragma config WINDIS = OFF
    	#pragma config MCLRE = OFF, STVREN = OFF, LPBOR = OFF, WDT = OFF, WDTE = OFF,FNOSC = FRCPLL//, DSWDTOSC = LPRC
    	#pragma config SOSCSEL = OFF
    	#pragma config BOREN = OFF
    	#pragma config DSBOREN = OFF
	#endif

	PUBLIC void SetConfig(void)
	{
		__builtin_write_OSCCONL((uint8_t) (0x0100 & 0x00FF));
	    RCONbits.SWDTEN = 0;
	    RCON = 0x0000;
	    OSCTUN = 0x0000;
        //U1OTGCONbits.DPPULUP = 1;
	}
#else
	#error "Your MCU does not support Config_Words header!"
#endif
